<?php 
    // continue the session
    session_start();
    
    // Add includes to PHP files that I will need to access
    include 'php_only_scripts/database.php';
    include 'php_only_scripts/presentation.php';
    include 'php_only_scripts/users_presentation.php';

    // Init some variables
    $userRow=null;

    // Assume NOT gtg
    $gtg = false;

    // Create and Setup the database
    $db = new Database();
    $db->setupTmsDB();

    // Attempt to log in with this user
    $currentUser = $db->getLoggedInSessionUser(session_id());
    
    // Set passing variables to defaults
    $currentUsersCompany=-1;
    $sortNumber=-1;
    $accountStatus='ACTIVE';
    
    // If there is only one result for a username/password combo, then they are good to go.
    if ($currentUser == null){
        exit;
    }
    elseif (mysqli_num_rows($currentUser)==1){
        // Attempt to get the user row
        $userRow = $currentUser->fetch_assoc();
        
        // Determine if this user is allowed here or not
        if ($userRow["SUEmployee"]==1 && 
            $userRow["AccountStatus"]=='ACTIVE' &&
            $userRow["UserLevel"]!='TIMECARD ONLY' &&
                ($userRow["UserLevel"]!='SU' ||
                 $userRow["UserLevel"]!='EXECUTIVE')){
            // Set the global variable to the new value of the combo box
            $currentUsersCompany = $userRow["CompanyID"];

            // Determine if there is a sort preference
            if (isset($_GET['sn']) ){
                // Hold onto the sort info
                $sortNumber = $_GET['sn'];
            }

            // Determine if there is an account status
            if (isset($_GET['as']) ){
                // Hold onto the account status
                $accountStatus = $_GET['as'];
            }
        }
        else {
                // redirect to the invalid access page
                echo ('<script>window.location = "invalid_access.php";</script>');
                
                exit;
        }
        
        // Set the good to go until they log out
        $gtg = true;
    }

?>
        
﻿<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

    <title>Task Management System - Account - EES Employees</title>

    <meta name="keywords" content="GIS,data,testing,IT" />
    <meta name="description" content="EES Employees." />

    <script src="./SpryAssets/SpryMenuBar.js" type="text/javascript"></script>
    <script src="scripts/jquery-ui-1.10.4.custom/js/jquery-1.10.2.js" type="text/javascript"></script>
    <script src="scripts/jquery-ui-1.11.4.custom/jquery-ui.js" type="text/javascript"></script>

    <link rel="icon" href="images/ees_ico.ico"/> 
    <link href="scripts/jquery-ui-1.10.4.custom/development-bundle/themes/smoothness/jquery-ui.css" rel="stylesheet" type="text/css"/>
    <link href="./SpryAssets/SpryMenuBarHorizontal.css" rel="stylesheet" type="text/css" />
    <link href="./SpryAssets/SpryMenuBarVertical.css" rel="stylesheet" type="text/css" />
    <link rel = "stylesheet" type="text/css" href="./css/contentpage.css" >
        
    <style type="text/css">
        .Table
        {
            display: table;
            width: 100%;
        }
        .Title
        {
            display: table-caption;
            text-align: center;
            font-weight: bold;
            font-size: larger;
        }
        .Heading
        {
            display: table-row;
            font-weight: bold;
            text-align: center;
            width: 100%;
        }
        .Row
        {
            display: table-row;
            width: 100%;
        }
        .cell
        {
            display: table-cell;
            border: solid;
            border-width: thin;
            padding-left: 2px;
            padding-right: 2px;
            font-weight: bold;
            font-size: 15;
        }
        .nameCell
        {
            width: 15%;
            text-align: center;
        }
        .levelCell
        {
            width: 15%;
            text-align: center;
        }
        .companyNameCell
        {
            text-align: left;
        }
        .updateCell
        {
            width: 12%;
            text-align: center;
        }
        span {
          display: inline-block;
          vertical-align: middle;
          line-height: normal;      
        }
    </style>
    <script>
        var sessionID = "<?php echo session_id(); ?>";
        function clockOutAllEmployees() {
            // get the clock out time as a string
            var clockOutTime = document.getElementById("clockAllOutTime").value.replace("T", " ");
            
            // Setup the parameters to pass to PHP
            var params = {
                "sessionID" : sessionID,
                "clockAllOutTime" : clockOutTime
            };

            // Create the string containing the PHP file to use
            var url = "php_only_scripts/jquery_only/clock_out_all.php";

            // Setup AJAX for communication
            $.ajax({
                context : this,
                type    : "GET", 
                url     : url, 
                data    : params, 
                dataType: "html", 
                encode  : true,
                async   : false, 
                cache   : false
            })
            .done(function(data){
                // Check to see if there is a reason NOT to allow the move
                if (data!==null && data.trim()!==""){
                    // Give an alert popup
                    alert(data.trim());
                }
            })
            .fail(function(data){   
                // Log any errors to the console
                console.log(data);
            }); 
        }
        
        function CreateURLSearchVariables() {
            // Get all of the variables
            var sortNumber = (document.getElementById('sortNumber')===null || document.getElementById('sortNumber').value===null)?'sn=1':'sn='+document.getElementById('sortNumber').value;
            var accountStatus = (document.getElementById('accountStatus')===null || document.getElementById('accountStatus').value===null)?'&as=ACTIVE':'&as='+document.getElementById('accountStatus').value;
                
            // Return what we can build up
            return '\?' + sortNumber + accountStatus;
        }
        
        function CreateAndGotoSearchOptions() {
            // Get the base location
            var goToLocation = window.location.href.split('?')[0];

            // Build the location to go to with get variables
            goToLocation = goToLocation + CreateURLSearchVariables();
            
            // Go to the location built
            window.location=goToLocation;
        }
    </script>
</head>

<body class="thrColElsHdr">

<div id="container">
  
<!-- start of banner wrap --->

<div id="topContent">
  
<div>
   <div class="MenuBarHorizontal" id="navBar">  <ul id="TopNav" class="MenuBarHorizontal">

    <script type="text/javascript">
    <!--
    var MenuBar2 = new Spry.Widget.MenuBar("TopNav", {imgDown:"./SpryAssets/SpryMenuBarDownHover.gif", imgRight:"./SpryAssets/SpryMenuBarRightHover.gif"});
    //-->
    </script>

    </div>
  </div>
</div>
<!-- end of banner wrap --->

  <!-- end #header -->
  <br class="clearfloat" />
  <div id="sidebar1">
      <?php 
        // Determine if we are GTG
        if ($gtg){
            // Render the appropriate presentation for the tasks sidebar
            getSidebar($userRow, 'timecard');
        }
      ?>       
      <br class="clearfloat" />
  <!-- end #sidebar1 -->
  </div>
  
  <!-- start #mainContent -->
  <div id="mainContent">
    <div class="maintitle">Task Management System - EES Employee Timecards</div>
    <div class="breadcrumb"> <a href="index.html"> Home </a> > <a href="tasks.php"> Task Management System </a> > <a href="viewEmployeeTimecards.php"> EES Employee Timecards </a></div>

    <br>
        
    <?php
        // Determine if they are GTG
        if ($gtg){
            // Time to query for their tasks
            echo(retrieveUsersAsList($db, $userRow, 1, $currentUsersCompany, $accountStatus, $sortNumber));
        }
        else {
            // Set the login failed to true
            $_SESSION['failedLogin']='TRUE';

            // Add a session variable that is this page URL
            $_SESSION['pageToGoTo']=$_SERVER['REQUEST_URI'];

            // redirect to the login page
            echo ('<script>window.location = ".";</script>');
        }
    ?>       
    
  <!-- end #mainContent -->
  
  <!-- This clearing element should immediately follow the #mainContent div in order to force the #container div to contain all child floats -->
  <br class="clearfloat" />
  
  <!-- start #footer --></div>
   <div id="footer">
    <p>© 2018 Evolve Engineering and Software. EES, Evolve Engineering and Software, EES Logo are registered marks of Evolve Engineering and Software.</p>
  <!-- end #footer -->
   </div>
<!-- end #container -->
</div>

</body>

</html>